package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.managed.Receipt;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("GeneralReceipt")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class GeneralReceipt implements Marshallable {
	private long localBlock;
	private java.time.OffsetDateTime localBlockTime;
	private long directoryBlock;
	private long majorBlock;
	private Receipt proof;
	private String error;

    //
	public long getLocalBlock() {
	    return localBlock;
	}
	public void setLocalBlock(final long value) {
	    this.localBlock = value;
	}

	public GeneralReceipt localBlock(final long value) {
	    setLocalBlock(value);
	    return this;
	}
	public java.time.OffsetDateTime getLocalBlockTime() {
	    return localBlockTime;
	}
	public void setLocalBlockTime(final java.time.OffsetDateTime value) {
	    this.localBlockTime = value;
	}

	public GeneralReceipt localBlockTime(final java.time.OffsetDateTime value) {
	    setLocalBlockTime(value);
	    return this;
	}
	public long getDirectoryBlock() {
	    return directoryBlock;
	}
	public void setDirectoryBlock(final long value) {
	    this.directoryBlock = value;
	}

	public GeneralReceipt directoryBlock(final long value) {
	    setDirectoryBlock(value);
	    return this;
	}
	public long getMajorBlock() {
	    return majorBlock;
	}
	public void setMajorBlock(final long value) {
	    this.majorBlock = value;
	}

	public GeneralReceipt majorBlock(final long value) {
	    setMajorBlock(value);
	    return this;
	}
	public Receipt getProof() {
	    return proof;
	}
	public void setProof(final Receipt value) {
	    this.proof = value;
	}

	public GeneralReceipt proof(final Receipt value) {
	    setProof(value);
	    return this;
	}
	public String getError() {
	    return error;
	}
	public void setError(final String value) {
	    this.error = value;
	}

	public GeneralReceipt error(final String value) {
	    setError(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.localBlock == 0)) {
            marshaller.writeUint(1, this.localBlock);
        }
        if (!(this.localBlockTime == null)) {
            marshaller.writeTime(2, this.localBlockTime);
        }
        if (!(this.directoryBlock == 0)) {
            marshaller.writeUint(3, this.directoryBlock);
        }
        if (!(this.majorBlock == 0)) {
            marshaller.writeUint(4, this.majorBlock);
        }
        if (!(this.proof == null)) {
            marshaller.writeValue(5, proof);
        }
        if (!(this.error == null || this.error.length() == 0)) {
            marshaller.writeString(6, this.error);
        }
        return marshaller.array();
    }
}
